import satine
from satine.grapes import listener
from satine.grapes.dispatcher import Dispatcher
from satine.grapes.HTTP import run
from satine.stream import file2py
import os
import sys

class _list(satine.xlist):
    __tag__ = "list"    

class request(satine.xlist):
    pass

class added(satine.xlist):
    pass

class cuisine(satine.xlist):
    pass

class restaurant(satine.xlist):
    pass

satine.xspace(ics234="http://satine.sourceforge.net/schemas/ics234")

#----------------------------------------------------------------

cuisines = []
reviews = {}

class listen_for_reviews(listener):
    def init(self):
        for cuisine in self.model.iter(".<ics234:cuisine>|"):
            reviews[cuisine.type] = cuisine

    def list_reviews(self, type):
        res = _list(cuisine=type)
        self.reply(reviews[type], 200, "text/xml")
        
    def add_review(self, type, review):
        res = added(cuisine=type)
        if not type in reviews:
            self.reply("the cuisine is not available", 404, "text/plain")
            return
        
        reviews[type].append(review)
        res.append(review)
        self.reply(res, 200, "text/xml")
        
    def hnd_list(self, x):
        """<ics234:request action="list">"""
        self.list_reviews(x.type)        

    def hnd_add(self, x):
        """<ics234:request action="add"><ics234:review>"""
        self.add_review(x)

    def hnd_form_list(self, x):
        """<satine:Form action="list">"""
        self.list_reviews(x.type)        

    def hnd_form_add(self, x):
        """<satine:Form action="add">"""
        review = restaurant(comment=x.comment, name=x.name)
        self.add_review(x.type, review)        


    

class listen_for_all_cuisines(listener):
    def init(self):
        query = self.model.query("""<ics234:root><ics234:cuisine>|type""")
        for type in query:
            if type not in cuisines:
                cuisines.append(type)
        
    def list_cuisines(self):
        res = _list()
        for type in cuisines:
            item = cuisine(type=type)
            res.append(item)
        self.reply(res, 200, "text/xml")
        print cuisines

    def add_cuisines(self, type):
        res = added()
        if not type in cuisines:
            cuisines.append(type)
            item = cuisine(type=type)
            self.model.append(item)
            reviews[type] = item
            res.append(item)
        self.reply(res, 200, "text/xml")
        print cuisines

    def hnd_list(self, x):
        """<ics234:request action="list">"""
        self.list_cuisines()        

    def hnd_add(self, x):
        """<ics234:request action="add"><ics234:cuisine>"""
        self.add_cuisines(x.type)

    def hnd_form_list(self, x):
        """<satine:Form action="list">"""
        self.list_cuisines()        

    def hnd_form_add(self, x):
        """<satine:Form action="add">"""
        self.add_cuisines(x.type)        


if __name__ == "__main__":
    model = file2py("data.xml")
    dispatcher = Dispatcher(model)
    dispatcher.load("config.xml")
    print "Open your browser at the URL 'http://localhost:7580/cuisines_list.ssp?action=list'"
    run(dispatcher)    
    